using System;
using System.Windows.Forms;
using System.Threading;

namespace TabControlAdv_test
{
	/// <summary>
	/// Summary description for AppLoader.
	/// </summary>
	public sealed class AppLoader
	{
		private static bool m_bSplashEnabled;

		static AppLoader()
		{
			m_bSplashEnabled = true;	// Try setting this to false and everything works OK.
		}

		private AppLoader()
		{
		}

		public static bool SplashEnabled
		{
			get
			{
				return m_bSplashEnabled;
			}
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if ( AppLoader.SplashEnabled )
			{
				// Birta Splash formi
				Splasher.Show();
			}

			DoStartup(args);

			if ( AppLoader.SplashEnabled )
			{
				// Eya splash formi ef a er opi ( a eyast venjulega  rum sta)
				Splasher.Close();
			}
		}

		private static void DoStartup(string[] args)
		{
			Application.EnableVisualStyles();
			Application.Run(new Form1());
		}
	}
}
