using System;
using System.Threading;
using System.Windows.Forms;

namespace TabControlAdv_test
{
	/// <summary>
	/// Summary description for Splasher.
	/// </summary>
	public class Splasher
	{
		private static SplashForm m_oSplashForm = null;
		private static Thread m_oSplashThread = null;

		//	internally used as a thread function - showing the form and
		//	starting the messageloop for it
		private static void ShowThread() 
		{
			m_oSplashForm = new SplashForm();
			Application.Run(m_oSplashForm);
		}

		/// <summary>
		/// Birta Splash formi
		/// </summary>
		public static void Show() 
		{
			// Ef formi er egar til, htta  vi
			if (m_oSplashThread != null)
			{
				return;
			}

			// Ba til njan r til a birta formi.
			m_oSplashThread = new Thread(new ThreadStart(Splasher.ShowThread));
			m_oSplashThread.IsBackground = true;
			m_oSplashThread.ApartmentState = ApartmentState.STA;
			m_oSplashThread.Start();
		}

		/// <summary>
		/// Lokar Splash forminu.
		/// </summary>
		public static void Close() 
		{
			// Ef rurinn er egar tmur  er htt vi
			if (m_oSplashThread == null)
			{
				return;
			}

			// Ef staki af forminu er tmt er htt vi
			if (m_oSplashForm == null)
			{
				return;
			}

			// Loka forminu
			m_oSplashForm.Invoke(new MethodInvoker(m_oSplashForm.Close));
			

			// Hreinsa til
			m_oSplashThread = null;
			m_oSplashForm = null;
		}

		/// <summary>
		/// Status texti  forminu.
		/// </summary>
		public static string Status 
		{
			set 
			{
				if (m_oSplashForm == null) 
				{
					return;
				}

				m_oSplashForm.StatusInfo = value;
			}
			get 
			{
				if (m_oSplashForm == null) 
				{
					throw new InvalidOperationException("Splash Form not on screen");
				}

				return m_oSplashForm.StatusInfo;
			}
		}
	}
}
